bool CheckIndicators(int swing_handle, int numCopied){
       
       if(BarsCalculated(swing_handle)<numCopied)return(false); 
       if(BarsCalculated(HighTF_swing_handle)<numCopied)return(false); 
       if(BarsCalculated(HandleSuppResPeriodFast)<numCopied)return(false); 
       if(BarsCalculated(HandleSuppResPeriodSlow)<numCopied)return(false); 
       return(true);
        }
        
bool ComputeIndicators(int swing_handle)
{

       int maxLen;
       maxLen=10;
       
       if(CopyBuffer(HandleSuppResPeriodFast,UPPER_BAND,0,maxLen,ResistanceBuffer_PeriodFast)<=0)return(false);
       if(CopyBuffer(HandleSuppResPeriodFast,LOWER_BAND,0,maxLen,SupportBuffer_PeriodFast)<=0)return(false);
       
       if(CopyBuffer(HandleSuppResPeriodSlow,UPPER_BAND,0,maxLen,ResistanceBuffer_PeriodSlow)<=0)return(false);
       if(CopyBuffer(HandleSuppResPeriodSlow,LOWER_BAND,0,maxLen,SupportBuffer_PeriodSlow)<=0)return(false);
       
       ArraySetAsSeries(MACDMod_FastMA,true);
       if(CopyBuffer(swing_handle, 0, 0, maxLen, MACDMod_FastMA) <= 0)
          return(false);
       ArraySetAsSeries(MACDMod_SlowMA, true);
       if(CopyBuffer(swing_handle, 1, 0, maxLen, MACDMod_SlowMA) <= 0)
          return(false);
       ArraySetAsSeries(FastMA, true);
       if(CopyBuffer(swing_handle, 2, 0, maxLen, FastMA) <= 0)
          return(false);  
       ArraySetAsSeries(SlowMA, true);
       if(CopyBuffer(swing_handle, 3, 0, maxLen, SlowMA) <= 0)
          return(false);       
          
          
       ArraySetAsSeries(MACDMod_FastMA_HighTF,true);
       if(CopyBuffer(HighTF_swing_handle, 0, 0, maxLen, MACDMod_FastMA_HighTF) <= 0)
          return(false);
       ArraySetAsSeries(MACDMod_SlowMA_HighTF, true);
       if(CopyBuffer(HighTF_swing_handle, 1, 0, maxLen, MACDMod_SlowMA_HighTF) <= 0)
          return(false);
       ArraySetAsSeries(FastMA_HighTF, true);
       if(CopyBuffer(HighTF_swing_handle, 2, 0, maxLen, FastMA_HighTF) <= 0)
          return(false);  
       ArraySetAsSeries(SlowMA_HighTF, true);
       if(CopyBuffer(HighTF_swing_handle, 3, 0, maxLen, SlowMA_HighTF) <= 0)
          return(false); 

       return(true);
       }
       
       
bool CheckForSupport(string symbol_local, ENUM_TIMEFRAMES timeframelocal, double currPrice, double pointLocal){ 
        double rng=ResistanceBuffer_PeriodFast[0]-SupportBuffer_PeriodFast[0];
        double revWin=rng*ReversalWindow/100.0;
        if(rng<MinimumRangeSize*pointLocal)return(false);
        if((iClose(symbol_local,timeframelocal,0)<=SupportBuffer_PeriodFast[0]+revWin
           && iClose(symbol_local,timeframelocal,1)>=SupportBuffer_PeriodFast[0]+revWin) ||
           (iClose(symbol_local,timeframelocal,0)>=SupportBuffer_PeriodFast[0]+revWin
           && iClose(symbol_local,timeframelocal,1)<=SupportBuffer_PeriodFast[0]+revWin))return(true);
        return(false);
        }

        
bool CheckForResistance(string symbol_local, ENUM_TIMEFRAMES timeframelocal, double currPrice, double pointLocal){ 
        double rng=ResistanceBuffer_PeriodFast[0]-SupportBuffer_PeriodFast[0];
        double revWin=rng*ReversalWindow/100.0;
        if(rng<MinimumRangeSize*pointLocal)return(false);
        if((iClose(symbol_local,timeframelocal,0)>=ResistanceBuffer_PeriodFast[0]-revWin
           && iClose(symbol_local,timeframelocal,1)<=ResistanceBuffer_PeriodFast[0]-revWin) ||
           (iClose(symbol_local,timeframelocal,0)<=ResistanceBuffer_PeriodFast[0]-revWin
           && iClose(symbol_local,timeframelocal,1)>=ResistanceBuffer_PeriodFast[0]-revWin))return(true);
        return(false);
        }   
        
bool CheckForBuy(string symbol_local, ENUM_TIMEFRAMES timeframelocal, double currPrice, double pointLocal){
       int currIndx=0;
       bool suppReversal;
       
       suppReversal=CheckForSupport(symbol_local, timeframelocal, currPrice, pointLocal);
         
       if(suppReversal){
          if(UseTrendFilter && (MACDMod_FastMA_HighTF[currIndx]<MACDMod_SlowMA_HighTF[currIndx] ||
             FastMA_HighTF[currIndx]<SlowMA_HighTF[currIndx] ))return(false);
           
          if(UseRangeTrendAccord && ((SupportBuffer_PeriodFast[currIndx+1]<SupportBuffer_PeriodSlow[currIndx+1]) ||
             (SupportBuffer_PeriodFast[currIndx]<SupportBuffer_PeriodSlow[currIndx])))return(false);
               
          if(UseTrendFilter && MACDMod_FastMA[currIndx]<MACDMod_SlowMA[currIndx])return(false);  
              
          return(true);
          }
        return(false);
        }
        
 
bool CheckForSell(string symbol_local, ENUM_TIMEFRAMES timeframelocal, double currPrice, double pointLocal){
       int currIndx=0;
       bool resReversal;
       
       resReversal=CheckForResistance(symbol_local, timeframelocal, currPrice, pointLocal);
         
       if(resReversal){
          if(UseTrendFilter && (MACDMod_FastMA_HighTF[currIndx]>MACDMod_SlowMA_HighTF[currIndx] ||
              FastMA_HighTF[currIndx]>SlowMA_HighTF[currIndx]))return(false);
               
          if(UseRangeTrendAccord && (ResistanceBuffer_PeriodFast[currIndx]>ResistanceBuffer_PeriodSlow[currIndx]
             || ResistanceBuffer_PeriodFast[currIndx+1]>ResistanceBuffer_PeriodSlow[currIndx+1]))
             return(false);
               
          if(UseTrendFilter && MACDMod_FastMA[currIndx]>MACDMod_SlowMA[currIndx])return(false);
                
          return(true);
          }
        return(false);
        } 
        
bool NewBar(datetime CurrBarTimeLocal, string SymbolLocal, ENUM_TIMEFRAMES TimeFrameLocal){
 
 // Return true if a new bar has been started otherwise false.
 
        if(CurrBarTimeLocal != iTime(SymbolLocal,TimeFrameLocal,0)) return(true);
        
        return(false);
        
        } 
        
bool AllTrailing(string symbolLocal, ENUM_TIMEFRAMES timeFrameLocal, long MagicNumber){
       int numOrders=PositionsTotal();
       ulong currTicket;
       double SL, openPrice;
       for(int i=numOrders-1; i>=0; i--){
          currTicket=PositionGetTicket(i);
          if(IsInTickets(currTicket, MartingaleBuyTickets))continue;
          if(IsInTickets(currTicket, MartingaleSellTickets))continue; 
          
          if(PositionSelectByTicket(currTicket)){
            if(PositionGetInteger(POSITION_MAGIC)!=MagicNumber)continue;
            if(PositionGetString(POSITION_SYMBOL)!=symbolLocal)continue;
            SL=PositionGetDouble(POSITION_SL);
            openPrice=PositionGetDouble(POSITION_PRICE_OPEN);
            if(SL==0.0)continue;
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY && SL<openPrice)return(false);
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL && SL>openPrice)return(false);
          }
        }
       return(true);
     }  
     
double ComputeDrawDown(string symbol_local, long MagicNumber, double askprice, double bidprice, ENUM_POSITION_TYPE direction,
                                double &netLotsize, double &avgOpenPrice){

         int numOrders=PositionsTotal();
         ulong currTicket;
         double L_i=0.0, L_Del=0.0, Del_net=0.0;
         double openPr, posSL;
         avgOpenPrice=0.0;
         for(int i=numOrders-1; i>=0; i--){
         
            currTicket=PositionGetTicket(i);
            
            if(IsInTickets(currTicket, MartingaleBuyTickets))continue;
            if(IsInTickets(currTicket, MartingaleSellTickets))continue; 
                      
            if(PositionSelectByTicket(currTicket)){
              openPr=PositionGetDouble(POSITION_PRICE_OPEN);
              posSL=PositionGetDouble(POSITION_SL);
              if(PositionGetInteger(POSITION_TYPE)!=direction)continue;
              if(PositionGetInteger(POSITION_MAGIC)!=MagicNumber)continue;
              if(PositionGetString(POSITION_SYMBOL)!=symbol_local)continue;
              if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_BUY && posSL>openPr)continue;
              if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_SELL && posSL<openPr)continue;
              if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_BUY){
                 L_i+=PositionGetDouble(POSITION_VOLUME);
                 L_Del+=(bidprice-PositionGetDouble(POSITION_PRICE_OPEN))*PositionGetDouble(POSITION_VOLUME);
                 avgOpenPrice+=PositionGetDouble(POSITION_PRICE_OPEN)*PositionGetDouble(POSITION_VOLUME);
                 }
              if(PositionGetInteger(POSITION_TYPE)==ORDER_TYPE_SELL){
                 L_i+=PositionGetDouble(POSITION_VOLUME);
                 L_Del+=(PositionGetDouble(POSITION_PRICE_OPEN)-askprice)*PositionGetDouble(POSITION_VOLUME);
                 avgOpenPrice+=PositionGetDouble(POSITION_PRICE_OPEN)*PositionGetDouble(POSITION_VOLUME);
                 }
               }
             }
             

         if(L_i<=0.0)return(0.0);
         avgOpenPrice=avgOpenPrice/L_i;    
         Del_net=L_Del/L_i;
         netLotsize=L_i;   
         return(Del_net);
         } 
         
bool ProfitLine_DD(string symbol_local, long MagicNumber, double askprice, double bidprice, ENUM_POSITION_TYPE posType, ulong &ticketArrayB[], 
                   ulong &ticketArrayS[],double &breakEvenLine, double targetProfit, double &targetProfitline){
         int numOrders;
         ulong currTicket;
         double L_i=0.0, LOp_i=0.0, beLine=0.0;
         
         if(posType==POSITION_TYPE_BUY){
           numOrders=ArraySize(ticketArrayB);
           }
         else{
           if(posType==POSITION_TYPE_SELL){
             numOrders=ArraySize(ticketArrayS);
             }
           else{
             return(false);
             }
           }   
              
         for(int i=numOrders-1; i>=0; i--){
            currTicket=(posType==POSITION_TYPE_BUY)?(ulong)ticketArrayB[i]:(ulong)ticketArrayS[i];
            if(PositionSelectByTicket(currTicket)){
              if(PositionGetInteger(POSITION_MAGIC)!=MagicNumber)continue;
              if(PositionGetString(POSITION_SYMBOL)!=symbol_local)continue;
              if(PositionGetInteger(POSITION_TYPE)==posType){
                 L_i+=PositionGetDouble(POSITION_VOLUME);
                 LOp_i+=PositionGetDouble(POSITION_VOLUME)*PositionGetDouble(POSITION_PRICE_OPEN);
   
                 }  
              
              }
            }
          if(L_i<=0.0)return(false);
          
// Compute the lines.

          breakEvenLine=LOp_i/L_i;
          
          if(posType==POSITION_TYPE_BUY){
            targetProfitline=targetProfit+breakEvenLine;
            }
          if(posType==POSITION_TYPE_SELL){
            targetProfitline=breakEvenLine-targetProfit;
            }
            
         return(true);
         }         
           
bool CloseOrderList(ulong &ticketArray[]){
        bool success=true;
        int ArrLen=ArraySize(ticketArray);
        CTrade DDtrades;
            
        for(int i=0; i<ArrLen; i++){
           if(!DDtrades.PositionClose(ticketArray[i])){
              success=false;
              }
            }
                
        return(success);
        }         
         
void GetDDInitTickets(string symbol_local, long MagicNumber, ENUM_POSITION_TYPE tradeType, ulong &ticketsArr[]){
         int numOrders=PositionsTotal();
         int arrLen; 
         ulong currTicket;
         double posSL, openPr;
         CTrade DDtrades;
        
         for(int i=numOrders-1; i>=0; i--){  
            currTicket=PositionGetTicket(i);         
            if(IsInTickets(currTicket, MartingaleBuyTickets))continue;
            if(IsInTickets(currTicket, MartingaleSellTickets))continue; 
           
            if(PositionSelectByTicket(currTicket)){   
              posSL=PositionGetDouble(POSITION_SL);
              openPr=PositionGetDouble(POSITION_PRICE_OPEN);
              if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY && posSL>openPr)continue;
              if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL && posSL<openPr)continue;        
              if(PositionGetInteger(POSITION_MAGIC)!=MagicNumber)continue;
              if(PositionGetString(POSITION_SYMBOL)!=symbol_local)continue;
              if(PositionGetInteger(POSITION_TYPE)!=tradeType)continue;
              ArrayResize(ticketsArr,ArraySize(ticketsArr)+1);
              arrLen=ArraySize(ticketsArr);
              ticketsArr[arrLen-1]=currTicket;
              DDtrades.PositionModify(currTicket,0,0);
              }
           
            }
            
        return;
        } 
                       
     
bool IsInTickets(ulong ticketNum, ulong &ticketArray[]){
        int ArrLen=ArraySize(ticketArray);
        for(int i=0; i<ArrLen; i++){
          if(ticketNum == ticketArray[i])return(true);
          }
        return(false);
        }     
     
void TrailingStopTrail(long MagicNumber, ENUM_POSITION_TYPE type,double TS,double step,double start) //set Stop Loss to "TS" if price is going your way with "step"
  {
   TS = NormalizeDouble(TS, Digits());
   step = NormalizeDouble(step, Digits());
   start = NormalizeDouble(start, Digits());
   MqlTick last_tick;
   CTrade DDtrades;
   ulong currTicket;
   double minstopLevel;
   bool success;
   int total = PositionsTotal();
   for(int i = total-1; i >= 0; i--)
     {
//      if(PositionGetTicket(i) <= 0)
//         continue;
      currTicket=PositionGetTicket(i);   
      if(!PositionSelectByTicket(currTicket))continue;
// Ignore Draw Down reducer associated tickets.
      if(IsInTickets(currTicket, MartingaleBuyTickets))continue;
      if(IsInTickets(currTicket, MartingaleSellTickets))continue; 
            
      if(PositionGetInteger(POSITION_MAGIC) != MagicNumber || PositionGetString(POSITION_SYMBOL) != Symbol() || PositionGetInteger(POSITION_TYPE) != type)
         continue;
      SymbolInfoTick(Symbol(), last_tick);
      double SL = PositionGetDouble(POSITION_SL);
      double TP_former=PositionGetDouble(POSITION_TP);
      double currentprice = PositionGetDouble(POSITION_PRICE_CURRENT);
      double openprice = PositionGetDouble(POSITION_PRICE_OPEN);
      ulong ticket = PositionGetInteger(POSITION_TICKET);
      
      minstopLevel=(SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL)+SymbolInfoInteger(Symbol(),SYMBOL_SPREAD))*Point();
      if(type == POSITION_TYPE_BUY)
        {
//         if(last_tick.bid - openprice > TS + step)
            if(last_tick.bid - openprice > start && last_tick.bid-TS>SL)
               if(SL!=0 && TS>minstopLevel && (last_tick.bid-TS)-SL>step && last_tick.ask-(last_tick.bid-TS)>minstopLevel)
                 success=DDtrades.PositionModify(ticket,last_tick.bid-TS,TP_former);
//                  myOrderModify(ORDER_TYPE_BUY, ticket, last_tick.bid - TS, 0);
        }

      if(type == POSITION_TYPE_SELL)
        {
//         if(openprice - last_tick.ask > TS + step)
//            if(openprice - currentprice > start)
              if(openprice-last_tick.ask>start && last_tick.ask+TS<SL)
               if(SL!=0 && TS>minstopLevel && SL-(last_tick.ask+TS)>step && (last_tick.ask + TS)-last_tick.bid>minstopLevel)
                  success=DDtrades.PositionModify(ticket,last_tick.ask + TS,TP_former);
//                  myOrderModify(ORDER_TYPE_SELL, ticket, last_tick.ask + TS, 0);

        }
     }
  }
                                 
                 
        
bool CheckMoneyForTrade(string symb,double lots,ENUM_ORDER_TYPE type)
  {
//--- Getting the opening price
   MqlTick mqltick;
   SymbolInfoTick(symb,mqltick);
   double price;
   double symbAsk, symbBid;
   CAccountInfo accountInfo;
//   symbAsk=SymbolInfoDouble(symb,SYMBOL_ASK);
//   symbBid=SymbolInfoDouble(symb,SYMBOL_BID);
   symbAsk=mqltick.ask;
   symbBid=mqltick.bid;
   price=symbAsk;
   if(type==ORDER_TYPE_SELL)
      price=symbBid;
//--- values of the required and free margin
   double required_margin,free_margin, usedMargin, marginLevel, futureLevel;
   usedMargin=AccountInfoDouble(ACCOUNT_MARGIN);
   marginLevel=AccountInfoDouble(ACCOUNT_MARGIN_LEVEL);
   free_margin=accountInfo.FreeMargin();
   required_margin=accountInfo.MarginCheck(symb,type,lots,price);
   
   futureLevel=0.0;
   if(usedMargin+required_margin>0){
     futureLevel=(marginLevel*usedMargin/(required_margin+usedMargin));
     }
   //--- if there are insufficient funds to perform the operation
   if(required_margin>free_margin)
     {
      //--- report the error and return false
      Print("Not enough money for ",EnumToString(type)," ",lots," ",symb," Error code=",GetLastError());
      return(false);
     }
//--- checking successful
   return(true);
  }     
  
ulong SendOrderFunction(string symbol_local, ENUM_ORDER_TYPE tradetype, double lotsizelocal, double tradeprice, ulong Magiclocal,
                       int slippagelocal, double stoplosslocal, double takeprofitlocal, string orderCommentLocal)
  { 
  
       CTrade tradeObj;
       MqlTradeResult  result={0};
       bool success;
       ulong ticket;
       int numTries=30;
 
         
          tradeObj.SetDeviationInPoints((ulong)slippagelocal);
          tradeObj.SetExpertMagicNumber((ulong)Magiclocal);
          success=tradeObj.SetTypeFillingBySymbol(symbol_local);
          success=tradeObj.PositionOpen(symbol_local,tradetype,lotsizelocal,tradeprice,stoplosslocal,takeprofitlocal,orderCommentLocal);
          if(!success)return(0);
          tradeObj.Result(result);
          if(!PositionSelectByTicket(tradeObj.ResultOrder())){
             for(int i=0; i<numTries; i++){
                Sleep(200);
                if(HistoryOrderSelect(tradeObj.ResultOrder()))break;
                }
             }
          if(tradeObj.ResultRetcode()==10008 || tradeObj.ResultRetcode()==10009){
            ticket=tradeObj.ResultOrder();
            
            ZeroMemory(success);
            return(ticket);
            }
 
          ZeroMemory(success);
          ZeroMemory(ticket);
          return(0);
              
   }

  
double NormalizeVolume(const double volume,string SymbolLocal)
  {
   if(SymbolLocal==NULL || SymbolLocal=="") SymbolLocal=Symbol();
   double volumeStep=SymbolInfoDouble(SymbolLocal,SYMBOL_VOLUME_STEP);
   double volumeMin=SymbolInfoDouble(SymbolLocal,SYMBOL_VOLUME_MIN);
   double volumeMax=SymbolInfoDouble(SymbolLocal,SYMBOL_VOLUME_MAX);
   double volumeNormalized=int(volume/volumeStep)*volumeStep;
   return(volumeNormalized<volumeMin?volumeMin:(volumeNormalized>volumeMax?volumeMax:volumeNormalized));
  }                             