//+------------------------------------------------------------------+
//|                                                       swing3.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_plots 4


#property indicator_type1   DRAW_LINE
#property indicator_color1  clrYellow
#property indicator_width1  1

#property indicator_type2   DRAW_LINE
#property indicator_color2  clrMediumTurquoise
#property indicator_width2  1

#property indicator_type3   DRAW_FILLING
#property indicator_color3  clrDarkSlateBlue,clrMaroon
#property indicator_width3  1

input int ma_1 = 28;
input int ma_2 = 144;
input ENUM_MA_METHOD method = MODE_LWMA;
input ENUM_APPLIED_PRICE price = PRICE_CLOSE;
input int signal = 14;
input int signal2 = 70;
input ENUM_MA_METHOD s_method2 = MODE_SMA;
input ENUM_MA_METHOD s_method = MODE_SMA;
input color color1 = clrDarkSlateBlue;
input color color2 = clrMaroon;
input color color3 = clrYellow;
input color color4 = clrMediumTurquoise;
ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT;

double FirstLine[];
int FirstLineHandle;

double SecondLine[];
int SecondLineHandle;

double ExtMapBuffer1[];
int ExtMapBuffer1Handle;

double ExtMapBuffer2[];
int ExtMapBuffer2Handle;

double SignalMap[];
double SignalMap2[];

double MACD_Map[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
   SetIndexBuffer(0, FirstLine);
   //SetIndexStyle(0, DRAW_LINE, 1, STYLE_SOLID, color3);
   
   SetIndexBuffer(1, SecondLine);
   //SetIndexStyle(1, DRAW_LINE, 1, STYLE_SOLID, color4);
   
   SetIndexBuffer(2, ExtMapBuffer1, INDICATOR_DATA);
   //SetIndexStyle(2,DRAW_FILLING, STYLE_SOLID, 6, color1);

   SetIndexBuffer(3, ExtMapBuffer2, INDICATOR_DATA);
   //SetIndexStyle(3 ,DRAW_FILLING, STYLE_SOLID, 6, color2);

   SetIndexBuffer(4,MACD_Map, INDICATOR_DATA);
   //SetIndexStyle(4,DRAW_NONE);
 
   SetIndexBuffer(5,SignalMap, INDICATOR_DATA);    
   //SetIndexStyle(5,DRAW_NONE); 
   
   SetIndexBuffer(6,SignalMap2, INDICATOR_DATA);    
   //SetIndexStyle(6,DRAW_NONE); 
   
   ExtMapBuffer1Handle = iMA(_Symbol, 0, ma_1, 0, method, price);
   ExtMapBuffer2Handle = iMA(_Symbol, 0, ma_2, 0, method, price);

   IndicatorSetString(INDICATOR_SHORTNAME,"Ahmed-bh91@hotmail.com");
   PlotIndexSetString(0,PLOT_LABEL,"Ahmed-bh91@hotmail.com");
   PlotIndexSetString(1,PLOT_LABEL,"Ahmed-bh91@hotmail.com");
   PlotIndexSetString(2,PLOT_LABEL,"Ahmed-bh91@hotmail.com");
   PlotIndexSetString(3,PLOT_LABEL,"Ahmed-bh91@hotmail.com");
   
   ObjectCreate(0,"Test",OBJ_LABEL,0,0,0,0,0,0,0);
   
ObjectSetString(0,"Test",OBJPROP_TEXT,"Ahmed-bh91@hotmail.com");
   
ObjectSetInteger(0,"Test",OBJPROP_XDISTANCE,50);
ObjectSetInteger(0,"Test",OBJPROP_YDISTANCE,50);
ObjectSetInteger(0,"Test",OBJPROP_CORNER,CORNER_LEFT_UPPER);
   
ObjectSetInteger(0,"Test",OBJPROP_COLOR,clrAliceBlue);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
    if(prev_calculated==0)
     {
      //--- Copy all the values of the indicators to the appropriate buffers
      int copied1=CopyBuffer(ExtMapBuffer1Handle,0,0,rates_total,ExtMapBuffer1);
      int copied2=CopyBuffer(ExtMapBuffer2Handle,0,0,rates_total,ExtMapBuffer2);
     }
   else // Fill only those data that are updated
     {
      //--- Get the difference in bars between the current and previous start of OnCalculate()
      int to_copy=rates_total-prev_calculated;
      //--- If there is no difference, we still copy one value - on the zero bar
      if(to_copy==0) to_copy=1;
      //--- copy to_copy values to the very end of indicator buffers
      int copied1=CopyBuffer(ExtMapBuffer1Handle,0,0,rates_total,ExtMapBuffer1);
      int copied2=CopyBuffer(ExtMapBuffer2Handle,0,0,rates_total,ExtMapBuffer2);
     }
   
   int pos;
   if(prev_calculated==0) pos=0;
   else pos=prev_calculated-1;   
   
   while (pos < rates_total) {  
   
      MACD_Map[pos]=ExtMapBuffer1[pos]-ExtMapBuffer2[pos];
      pos++;
   
   }
   
   if(prev_calculated==0) pos=0;
   else pos=prev_calculated-1;  
      
   while (pos < rates_total) {    

      SignalMap[pos]=  SimpleMA(pos, signal, MACD_Map);
      FirstLine[pos]= NormalizeDouble(ExtMapBuffer2[pos]+SignalMap[pos],Digits());
   
      SignalMap2[pos]=  SimpleMA(pos, signal2, MACD_Map);
      SecondLine[pos]= NormalizeDouble(SignalMap2[pos]+ExtMapBuffer2[pos],Digits());
      
      pos++;   
   }
   
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

   void SetIndexStyle (int index, int type = DRAW_LINE, int width = 1, int style = STYLE_SOLID, color clr = clrRed) {
      PlotIndexSetInteger(index, PLOT_DRAW_TYPE, type);
      PlotIndexSetInteger(index, PLOT_LINE_WIDTH, width);
      PlotIndexSetInteger(index, PLOT_LINE_STYLE, style);
      PlotIndexSetInteger(index, PLOT_LINE_COLOR, clr);
   }

double iMAOnArray (
   const int position,
   const int period,
   double prev_value,
   const double &price[], 
   ENUM_MA_METHOD method
) {

   double result=0.0;

   if (method == MODE_SMA) {
   
      result = SimpleMA(position, period, price);
   
   }
   
   if (method == MODE_EMA) {
   
      result = ExponentialMA(position, period, prev_value, price);
   
   }
   
   if (method == MODE_SMA) {
   
      result = SmoothedMA(position, period, prev_value, price);
   
   }
   
   if (method == MODE_LWMA) {
   
      result = LinearWeightedMA(position, period, price);
   
   }

   return result;

}

//+------------------------------------------------------------------+
//| Simple Moving Average                                            |
//+------------------------------------------------------------------+
double SimpleMA(const int position,const int period,const double &price[])
  {
//---
   double result=0.0;
//--- check position
   if(position>=period-1 && period>0)
     {
      //--- calculate value
      for(int i=0;i<period;i++) result+=price[position-i];
      result/=period;
     }
//---
   return(result);
  }
//+------------------------------------------------------------------+
//| Exponential Moving Average                                       |
//+------------------------------------------------------------------+
double ExponentialMA(const int position,const int period,const double prev_value,const double &price[])
  {
//---
   double result=0.0;
//--- calculate value
   if(period>0)
     {
      double pr=2.0/(period+1.0);
      result=price[position]*pr+prev_value*(1-pr);
     }
//---
   return(result);
  }
//+------------------------------------------------------------------+
//| Smoothed Moving Average                                          |
//+------------------------------------------------------------------+
double SmoothedMA(const int position,const int period,const double prev_value,const double &price[])
  {
//---
   double result=0.0;
//--- check position
   if(period>0)
     {
      if(position==period-1)
        {
         for(int i=0;i<period;i++) result+=price[position-i];
         result/=period;
        }
      if(position>=period)
         result=(prev_value*(period-1)+price[position])/period;
     }
//---
   return(result);
  }
//+------------------------------------------------------------------+
//| Linear Weighted Moving Average                                   |
//+------------------------------------------------------------------+
double LinearWeightedMA(const int position,const int period,const double &price[])
  {
//---
   double result=0.0,sum=0.0;
   int    i,wsum=0;
//--- calculate value
   if(position>=period-1 && period>0)
     {
      for(i=period;i>0;i--)
        {
         wsum+=i;
         sum+=price[position-i+1]*(period-i+1);
        }
      result=sum/wsum;
     }
//---
   return(result);
  }
