#property copyright "Copyright 2020, Ahmed Abulfateh  Ahmed-bh91@hotmail.com"
#property description "Strategy by Ahmed Abulfateh."
#property description "Coded by Emeka Nwankwo https://www.mql5.com/en/users/oraclesignals"
#property version   "7.00"
#property strict

#property tester_indicator "\\Indicators\\Ahmed\\swing3.ex5"

#resource "\\Indicators\\Ahmed\\swing3.ex5"

enum en_ExitType
  {
   Immediate,//Immediate
   Break,//Break Even
  };
//===============Trend Filter inputs======================
input bool   UseTrendFilter=true;//Turn on trend filter.
input ENUM_TIMEFRAMES Trend_Filter_Timeframe=PERIOD_H3;//Time Frame should be lower than chart timeframe
input int ma_1 = 28;
input int ma_2 = 144;
input ENUM_MA_METHOD method = MODE_LWMA;
input ENUM_APPLIED_PRICE AppPrice = PRICE_CLOSE;
input int signal = 14;
input int signal2 = 70;
input ENUM_MA_METHOD s_method2 = MODE_SMA;
input ENUM_MA_METHOD s_method = MODE_SMA;
input color color1 = clrDarkSlateBlue;
input color color2 = clrOrange;
input color color3 = clrRed;
input color color4 = clrMediumTurquoise;

//============================Support/Resistance inputs====================
input ENUM_TIMEFRAMES SuppResTimeFrame=PERIOD_CURRENT;// Support/Resistance Indicator Time Frame 1

input double ReversalWindow = 1.0;//Window for Support/Resistance reversal in percent.
input double MinimumRangeSize = 0.0;//Minimum difference between Resistance and support in points.
input int SuppResMAPeriodFast = 100;//Bollinger band MA period for support and resistance
input int SuppResMAPeriodSlow = 800;//Long Bollinger band MA period to determine BB trend direction.
input double SuppResStdDev = 1.5;//Bollinger band standard deviation
input bool UseRangeTrendAccord=false;//Set to true if the Bollinger band should be in trend direction.

//============================Indicator trade inputs=======================
// input int MagicNumber = 1213770;
input string IndicatorTradeComment="Support Resistance";
input double FixedLotSize = 0.01;
input int    TakeProfit = 10000;
input int StopLoss = 10000;
input int Slippage=10;
input int TrailingStart = 500;
input int TrailingStop = 150;
input int TrailingStep = 5;

//==========================Money Management==================
input bool EnableDDControl=true;
input double DDcontrolInitThresh=1400;
input double DDcontrolDistance=250;
input int DDcontrolMaxSeriesLen=10;
input double DDcontrolMultiplier=1;
input double DDcontrolProfit=200;
input string DDcontrolPosComment="DD control position.";
double MartiInitSL=10000;
double MartiInitTP=10000;

string indName="::Indicators\\Ahmed\\swing3.ex5";
// int swing_handle,HighTF_swing_handle,HandleSuppResPeriodFast,HandleSuppResPeriodSlow,ColorTF_swing_handle;
int HighTF_swing_handle,HandleSuppResPeriodFast,HandleSuppResPeriodSlow,ColorTF_swing_handle;

double FastMA[],SlowMA[], MACDMod_FastMA[], MACDMod_SlowMA[];
double FastMA_HighTF[],SlowMA_HighTF[], MACDMod_FastMA_HighTF[], MACDMod_SlowMA_HighTF[];

double SupportBuffer_PeriodFast[], ResistanceBuffer_PeriodFast[], SupportBuffer_PeriodSlow[],
       ResistanceBuffer_PeriodSlow[];
datetime CurrentBarTimeGlobal;

ulong MartingaleBuyTickets[], MartingaleSellTickets[];
int MartiCycleNumBuy, MartiCycleNumSell;
double CurrPriceThreshBuy, CurrPriceThreshSell, MartiInitLotsBuy, MartiInitLotsSell;
bool MartiActiveBuy, MartiActiveSell;

#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\AccountInfo.mqh>
#include "IncludeFolder/IncludeFile.mqh"

input string BASKET_CLOSE_INPUT = "*********BASKET CLOSE INPUT********"; //BASKET CLOSE INPUT
input bool inputUseBasketClose = false; //Basket Close
input double inputBasketCloseLossAmount = 0; //loss when to close option
input bool inputResetMartingaleAfterBasketClose = false; //Reset Martingale After Basket Close

input string SWING3_INDICATOR_FILTER_OPTIONS = "*********SWING3 INDICATOR FILTER OPTIONS********"; //SWING3 INDICATOR FILTER OPTIONS
input bool inputAllowSwing3IndicatorFilter = false; //Allow Swing3 Indicator Filter
input ENUM_TIMEFRAMES inputSwing3IndicatorTimeFrame = PERIOD_CURRENT; //Swing Ea Options

input string inputListOfPointsDiffrenceForFilter = "356, 170, 300, 506, 788, 140, 768, 730, 941, 414, 913, 917, 1063, 539"; //List Of Points Diffrence For Filter
int swing3IndicatorHandle;

input string SWING3_INDICATOR_ANY_OF_TWO_LINES_IS_OUT_FILTER_OPTIONS = "*********SWING3 INDICATOR ANY OF TWO LINES IS OUT FILTER OPTIONS********"; //SWING3 INDICATOR ANY OF TWO LINES IS OUT FILTER OPTIONS
input bool inputCloseOrBkevenAtSwing3CrossoverOutSideColoredArea = false; //Close Or Breakeven At Swing3 Crossover Outside Colored Area
input ENUM_TIMEFRAMES inputCloseOrBkevenAtSwing3CrossoverOutSideColoredAreaTimeFrame = PERIOD_H3; //Close Or Breakeven At Swing3 Crossover Outside Colored Area TimeFrame

enum ENUM_CLOSE_IMMEDIATELY_OR_CLOSE_AT_BREAKEVEN
  {
   CLOSE_IMMEDIATELY, //Close Immediately
   CLOSE_AT_BREAKEVEN, //Close At BreakEven
  };
  
input ENUM_CLOSE_IMMEDIATELY_OR_CLOSE_AT_BREAKEVEN inputSwing3TwoLinesCrossoverCloseType =  CLOSE_AT_BREAKEVEN; //Swing3 Two Lines Crossover Close Type
int swing3IndicatorHandleForTwoLines;

input string SWING3_INDICATOR_POINT_RANGE_FILTER_OPTIONS = "*********SWING3 INDICATOR POINT RANGE FILTER OPTIONS********"; //SWING3 INDICATORPOINT RANGE FILTER OPTIONS
input bool inputAllowSwing3IndicatorPointRangeFilter = false; //Allow Swing3 Indicator Point Range Filter
input ENUM_TIMEFRAMES inputSwing3IndicatorPointRangeFilterTimeFrame = PERIOD_H3; //Swing3 Point Range Filter Timeframe

input int inputAllowSwing3IndicatorPointRangeFilterLower = 170; //Swing3 Indicator Point Range Filter Lower
input int inputAllowSwing3IndicatorPointRangeFilterHigher = 500; //Swing3 Indicator Point Range Filter Higher

input bool   UseColorZoneFilter=false;//Turn on Colored Zone filter
input ENUM_TIMEFRAMES Color_Filter_Timeframe=PERIOD_H3;//Colored Zone filter timeframe
input en_ExitType ExitType = Immediate;//Exit type
int swing3IndicatorPointRangeFilterHandle;

enum SWING_THREE_INDICATOR_BUFFER
  {
   SWING_THREE_BUFFER_ONE,
   SWING_THREE_BUFFER_TWO,
   SWING_THREE_BULLISH_UPPER_LINE,
   SWING_THREE_BULLISH_LOWER_LINE,
  };

CTrade trade;

bool closeTradeAtBreakEven=false;

input string MULTI_TIMEFRAME = "*********MULTI TIMEFRAME********"; //MULTI TIMEFRAME

input bool inputAllowTimeFrame1 = true; //Allow TimeFrame 1
input ENUM_TIMEFRAMES inputTimeFrame1 = PERIOD_H1; //TimeFrame 1
input long inputTimeFrame1MagicNumber = 10001; //TimeFrame 1 MagicNumber

input bool inputAllowTimeFrame2 = true; //Allow TimeFrame 2
input ENUM_TIMEFRAMES inputTimeFrame2 = PERIOD_H1; //TimeFrame 2
input long inputTimeFrame2MagicNumber = 10002; //TimeFrame 2 MagicNumber

input bool inputAllowTimeFrame3 = true; //Allow TimeFrame 3
input ENUM_TIMEFRAMES inputTimeFrame3 = PERIOD_H1; //TimeFrame 3
input long inputTimeFrame3MagicNumber = 10003; //TimeFrame 3 MagicNumber

input bool inputAllowTimeFrame4 = true; //Allow TimeFrame 4
input ENUM_TIMEFRAMES inputTimeFrame4 = PERIOD_H1; //TimeFrame 4
input long inputTimeFrame4MagicNumber = 10004; //TimeFrame 4 MagicNumber

input bool inputAllowTimeFrame5 = true; //Allow TimeFrame 5
input ENUM_TIMEFRAMES inputTimeFrame5 = PERIOD_H1; //TimeFrame 5
input long inputTimeFrame5MagicNumber = 10005; //TimeFrame 5 MagicNumber

input bool inputAllowTimeFrame6 = true; //Allow TimeFrame 6
input ENUM_TIMEFRAMES inputTimeFrame6 = PERIOD_H1; //TimeFrame 6
input long inputTimeFrame6MagicNumber = 10006; //TimeFrame 6 MagicNumber

input bool inputAllowTimeFrame7 = true; //Allow TimeFrame 7
input ENUM_TIMEFRAMES inputTimeFrame7 = PERIOD_H1; //TimeFrame 7
input long inputTimeFrame7MagicNumber = 10007; //TimeFrame 7 MagicNumber

input bool inputAllowTimeFrame8 = true; //Allow TimeFrame 8
input ENUM_TIMEFRAMES inputTimeFrame8 = PERIOD_H1; //TimeFrame 8
input long inputTimeFrame8MagicNumber = 10008; //TimeFrame 8 MagicNumber

input bool inputAllowTimeFrame9 = true; //Allow TimeFrame 9
input ENUM_TIMEFRAMES inputTimeFrame9 = PERIOD_H1; //TimeFrame 9
input long inputTimeFrame9MagicNumber = 10009; //TimeFrame9 MagicNumber

input bool inputAllowTimeFrame10 = true; //Allow TimeFrame 10
input ENUM_TIMEFRAMES inputTimeFrame10 = PERIOD_H1; //TimeFrame 10
input long inputTimeFrame10MagicNumber = 10010; //TimeFrame 10 MagicNumber

struct TF_INDICATOR_HANDLE_MAGIC
{
  ENUM_TIMEFRAMES timeframe;
  int swingHandle;
  long magic;
};

TF_INDICATOR_HANDLE_MAGIC swingTfHandleAndMagicArr[];

int OnInit()
{
   ArraySetAsSeries(FastMA,true);
   ArraySetAsSeries(SlowMA,true);
   ArraySetAsSeries(MACDMod_FastMA,true);
   ArraySetAsSeries(MACDMod_SlowMA,true);

   ArraySetAsSeries(FastMA_HighTF,true);
   ArraySetAsSeries(SlowMA_HighTF,true);
   ArraySetAsSeries(MACDMod_FastMA_HighTF,true);
   ArraySetAsSeries(MACDMod_SlowMA_HighTF,true);

   ArraySetAsSeries(SupportBuffer_PeriodFast,true);
   ArraySetAsSeries(ResistanceBuffer_PeriodFast,true);
   ArraySetAsSeries(SupportBuffer_PeriodSlow,true);
   ArraySetAsSeries(ResistanceBuffer_PeriodSlow,true);

   ArrayResize(swingTfHandleAndMagicArr, 0);
   if(inputAllowTimeFrame1)
   {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame1,inputTimeFrame1MagicNumber))  return(INIT_FAILED);;
   }
    if(inputAllowTimeFrame2)
   {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame2,inputTimeFrame2MagicNumber))  return(INIT_FAILED);;
   }
  if(inputAllowTimeFrame3)
  {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame3,inputTimeFrame3MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame4)
  {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame4,inputTimeFrame4MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame5)
  {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame5,inputTimeFrame5MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame6)
  {
   if(!FillSwingTfHandleAndMagicArr(inputTimeFrame6,inputTimeFrame6MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame7)
  {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame7,inputTimeFrame7MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame8)
  {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame8,inputTimeFrame8MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame9)
  {
   if(!FillSwingTfHandleAndMagicArr(inputTimeFrame9,inputTimeFrame9MagicNumber))  return(INIT_FAILED);;
  }
  if(inputAllowTimeFrame10)
  {
    if(!FillSwingTfHandleAndMagicArr(inputTimeFrame10,inputTimeFrame10MagicNumber))  return(INIT_FAILED);;
  }

  //  swing_handle = iCustom(_Symbol, _Period,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
  //  if(!CheckSwingIndicatorHandle(swing_handle, _Period)) return(INIT_FAILED);

   swing3IndicatorHandle = iCustom(_Symbol, inputSwing3IndicatorTimeFrame,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
   if(!CheckSwingIndicatorHandle(swing3IndicatorHandle, inputSwing3IndicatorTimeFrame)) return(INIT_FAILED);
    
   swing3IndicatorHandleForTwoLines = iCustom(_Symbol, inputCloseOrBkevenAtSwing3CrossoverOutSideColoredAreaTimeFrame,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
   if(!CheckSwingIndicatorHandle(swing3IndicatorHandleForTwoLines, inputCloseOrBkevenAtSwing3CrossoverOutSideColoredAreaTimeFrame)) return(INIT_FAILED);
   
   ColorTF_swing_handle = iCustom(Symbol(), Color_Filter_Timeframe,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
   if(!CheckSwingIndicatorHandle(ColorTF_swing_handle, Color_Filter_Timeframe)) return(INIT_FAILED);
   
   swing3IndicatorPointRangeFilterHandle = iCustom(_Symbol, inputSwing3IndicatorPointRangeFilterTimeFrame,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
   if(!CheckSwingIndicatorHandle(swing3IndicatorPointRangeFilterHandle, inputSwing3IndicatorPointRangeFilterTimeFrame)) return(INIT_FAILED);
   
   HighTF_swing_handle = iCustom(Symbol(), Trend_Filter_Timeframe,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
   if(!CheckSwingIndicatorHandle(HighTF_swing_handle, Trend_Filter_Timeframe)) return(INIT_FAILED);
   
   HandleSuppResPeriodFast=iBands(Symbol(),SuppResTimeFrame,SuppResMAPeriodFast,0,SuppResStdDev,PRICE_CLOSE);
   if(!CheckIBandIndicatorHandle(HandleSuppResPeriodFast, SuppResTimeFrame)) return(INIT_FAILED);

   HandleSuppResPeriodSlow=iBands(Symbol(),SuppResTimeFrame,SuppResMAPeriodSlow,0,SuppResStdDev,PRICE_CLOSE);
   if(!CheckIBandIndicatorHandle(HandleSuppResPeriodSlow, SuppResTimeFrame)) return(INIT_FAILED);
  
   CurrentBarTimeGlobal=0;

   ArrayResize(MartingaleBuyTickets,0);
   ArrayResize(MartingaleSellTickets,0);
   MartiCycleNumBuy=0;
   MartiCycleNumSell=0;
   CurrPriceThreshBuy=EMPTY_VALUE;
   CurrPriceThreshSell=EMPTY_VALUE;
   MartiInitLotsBuy=0.0;
   MartiInitLotsSell=0.0;
   MartiActiveBuy=false;
   MartiActiveSell=false;

   return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason)
{
  IndicatorRelease(swing3IndicatorHandle);
  IndicatorRelease(swing3IndicatorHandleForTwoLines);
  IndicatorRelease(ColorTF_swing_handle);
  IndicatorRelease(swing3IndicatorPointRangeFilterHandle);
  IndicatorRelease(HighTF_swing_handle);
  IndicatorRelease(HandleSuppResPeriodFast);
  IndicatorRelease(HandleSuppResPeriodSlow);

  for(int i=0; i<ArraySize(swingTfHandleAndMagicArr); i++)
    IndicatorRelease(swingTfHandleAndMagicArr[i].swingHandle);

  ArrayResize(swingTfHandleAndMagicArr, 0);
}

void OnTick()
{
  for(int i=0; i<ArraySize(swingTfHandleAndMagicArr); i++)
  {
    if(swingTfHandleAndMagicArr[i].swingHandle != INVALID_HANDLE)
      HandleTrade(swingTfHandleAndMagicArr[i].timeframe, swingTfHandleAndMagicArr[i].swingHandle, swingTfHandleAndMagicArr[i].magic);
  }
}

void HandleTrade(ENUM_TIMEFRAMES tf, int swing_handle, long magic_number)
{  
   HandleBasketClose(magic_number);
   HandleSwing3TwoLineCrossoverOutSideColoredArea(magic_number);
   HandleCloseTradeAtBreakEven(magic_number);

   int numCopied=10;
   bool newbarflag, indicatorsReady, buyflag=false, sellflag=false;
   MqlTick mqltick;

   if(!CheckIndicators(swing_handle,numCopied))
     {
      Alert("Indicators are not ready");
      return;
     }
//-----------------------------------
   double MAfast = ValueBuffers(ColorTF_swing_handle,0,0);
   double MAslow = ValueBuffers(ColorTF_swing_handle,1,0);
   double A      = ValueBuffers(ColorTF_swing_handle,2,0);
   double B      = ValueBuffers(ColorTF_swing_handle,3,0);
   static string State = "Off";
   static string Exit = "";
//-----------------------------------
   double MAfast1 = ValueBuffers(ColorTF_swing_handle,0,1);
   double MAslow1 = ValueBuffers(ColorTF_swing_handle,1,1);
   double A1      = ValueBuffers(ColorTF_swing_handle,2,1);
   double B1      = ValueBuffers(ColorTF_swing_handle,3,1);
//-----------------------------------
   double MAfast2 = ValueBuffers(ColorTF_swing_handle,0,2);
   double MAslow2 = ValueBuffers(ColorTF_swing_handle,1,2);
   double A2      = ValueBuffers(ColorTF_swing_handle,2,2);
   double B2      = ValueBuffers(ColorTF_swing_handle,3,2);
//-----------------------------------
   if(UseColorZoneFilter)
     {
      if((MAfast1 > MAslow1 && MAfast2 <= MAslow2) || (MAfast1 < MAslow1 && MAfast2 >= MAslow2))
        {
         State = "Trade";
         Exit = "";
        }
      //---------------------------
      // Exit :>
      if(A1 < B1 && A2 < B2)
        {
         if(MAfast2 >= A2 && MAfast1 < A1)
           {
            Exit = "ExitSell";
            State = "NoTrade";
            if(ExitType == Immediate)
              {
               CloseTrades(_Symbol,magic_number,"Color filter Line exit condition");
               ResetMartingale();
              }
           }
        }
      else
         if(A1 > B1 && A2 > B2)
           {
            if(MAfast2 <= A2 && MAfast1 > A1)
              {
               Exit = "ExitBuy";
               State = "NoTrade";
               if(ExitType == Immediate)
                 {
                  CloseTrades(_Symbol,magic_number,"Color filter Line exit condition");
                  ResetMartingale();
                 }
              }
           }
      //----------
      if(ExitType == Break)
        {
         if((Exit == "ExitBuy" || Exit == "ExitSell")&& LivePNL(_Symbol,magic_number) >=0)
           {
            CloseTrades(_Symbol,magic_number,"Color filter Line exit condition BE");
            ResetMartingale();
            Exit = "";
           }
        }
     }
// Check for new bar.
   newbarflag=NewBar(CurrentBarTimeGlobal, Symbol(), tf);

   indicatorsReady=ComputeIndicators(swing_handle);
   if(!indicatorsReady)
     {
      Alert("Indicators are not ready");
      return;
     }

   if(indicatorsReady)
     {
      // Check for signal.
      buyflag=CheckForBuy(Symbol(), tf,iClose(Symbol(), tf,0),Point());
      sellflag=CheckForSell(Symbol(), tf,iClose(Symbol(), tf,0),Point());

     }
// End of check for new bar.
//           }
   double slPrice, tpPrice, modLotSize, openPrice, stopLevel;
   ulong ticket;
// Place trades.
   stopLevel = SymbolInfoInteger(_Symbol, SYMBOL_TRADE_STOPS_LEVEL) * Point();

   if(AllTrailing(Symbol(), tf, magic_number) && buyflag && !MartiActiveBuy && !MartiActiveSell && (State == "Trade" || State == "Off"))
     {
      SymbolInfoTick(Symbol(), mqltick);
      openPrice=mqltick.ask;
      slPrice=openPrice-StopLoss*Point()-stopLevel;
      tpPrice=openPrice+TakeProfit*Point()+stopLevel;
      modLotSize=NormalizeVolume(FixedLotSize,Symbol());
      if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) && MQLInfoInteger(MQL_TRADE_ALLOWED))
        {
         if(CheckMoneyForTrade(Symbol(),modLotSize,ORDER_TYPE_BUY) && CheckSwing3Filter() && CheckSwing3PoiintRangeFilter())
           {
            ticket = SendOrderFunction(Symbol(), ORDER_TYPE_BUY, modLotSize, mqltick.ask, magic_number,
                                       Slippage, slPrice, tpPrice, IndicatorTradeComment);
           }
        }

     }

   if(AllTrailing(Symbol(), tf, magic_number) && sellflag && !MartiActiveBuy && !MartiActiveSell && (State == "Trade" || State == "Off"))
     {
      SymbolInfoTick(Symbol(), mqltick);
      openPrice=mqltick.bid;
      slPrice=openPrice+StopLoss*Point()+stopLevel;
      tpPrice=openPrice-TakeProfit*Point()-stopLevel;
      modLotSize=NormalizeVolume(FixedLotSize,Symbol());
      if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) && MQLInfoInteger(MQL_TRADE_ALLOWED))
        {
         if(CheckMoneyForTrade(Symbol(),modLotSize,ORDER_TYPE_SELL) && CheckSwing3Filter() && CheckSwing3PoiintRangeFilter())
           {
            ticket = SendOrderFunction(Symbol(), ORDER_TYPE_SELL, modLotSize, mqltick.bid, magic_number,
                                       Slippage, slPrice, tpPrice, IndicatorTradeComment);
           }
        }

     }

   if(TrailingStop>0)
      TrailingStopTrail(magic_number, POSITION_TYPE_BUY, TrailingStop * Point(), TrailingStep * Point(),TrailingStart * Point()); //Trailing Stop = trail
   if(TrailingStop>0)
      TrailingStopTrail(magic_number, POSITION_TYPE_SELL, TrailingStop * Point(), TrailingStep * Point(),TrailingStart * Point()); //Trailing Stop = trail

//Martingale system is managed here.
   double drawDown, netLotSize, avgOpenPrice;
   CTrade DDtrades;
// Buy Trades.
   SymbolInfoTick(Symbol(), mqltick);
   drawDown=ComputeDrawDown(_Symbol, magic_number, mqltick.ask, mqltick.bid, POSITION_TYPE_BUY, netLotSize, avgOpenPrice)/Point();

   if(!MartiActiveBuy && EnableDDControl && drawDown<-DDcontrolInitThresh && netLotSize>0.0)
     {
      ArrayResize(MartingaleBuyTickets,0);
      GetDDInitTickets(_Symbol, magic_number, POSITION_TYPE_BUY, MartingaleBuyTickets);
      MartiInitLotsBuy=netLotSize;
      CurrPriceThreshBuy=avgOpenPrice;
      MartiActiveBuy=true;
      MartiCycleNumBuy=1;
     }
//Sell trades.
   drawDown=ComputeDrawDown(_Symbol, magic_number, mqltick.ask, mqltick.bid, POSITION_TYPE_SELL, netLotSize, avgOpenPrice)/Point();
   if(!MartiActiveSell && EnableDDControl && drawDown<-DDcontrolInitThresh && netLotSize>0.0)
     {
      ArrayResize(MartingaleSellTickets,0);
      GetDDInitTickets(_Symbol, magic_number, POSITION_TYPE_SELL, MartingaleSellTickets);
      MartiInitLotsSell=netLotSize;
      CurrPriceThreshSell=avgOpenPrice;
      MartiActiveSell=true;
      MartiCycleNumSell=1;
     }

//Check Martingale series for updates.
   double martiLots;
   if(MartiActiveBuy && (CurrPriceThreshBuy-iClose(_Symbol,tf,0))/_Point>DDcontrolDistance &&
      MartiCycleNumBuy<DDcontrolMaxSeriesLen)
     {
      martiLots=MartiInitLotsBuy*MathPow(DDcontrolMultiplier,MartiCycleNumBuy);
      slPrice=mqltick.ask-MartiInitSL*_Point;
      tpPrice=mqltick.ask+MartiInitTP*_Point;
      martiLots=NormalizeVolume(martiLots,_Symbol);
      if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) && MQLInfoInteger(MQL_TRADE_ALLOWED)&& (State == "Trade" || State == "Off"))
        {
         if(CheckMoneyForTrade(_Symbol,martiLots,ORDER_TYPE_BUY))
           {
            SymbolInfoTick(Symbol(), mqltick);
            slPrice=mqltick.ask-MartiInitSL*_Point;
            tpPrice=mqltick.ask+MartiInitTP*_Point;
            ticket = SendOrderFunction(_Symbol, ORDER_TYPE_BUY, martiLots, mqltick.ask, magic_number,
                                       Slippage, slPrice, tpPrice, DDcontrolPosComment);
            if(ticket>0)
              {
               ArrayResize(MartingaleBuyTickets,ArraySize(MartingaleBuyTickets)+1);
               MartingaleBuyTickets[ArraySize(MartingaleBuyTickets)-1]=ticket;
               CurrPriceThreshBuy=iClose(_Symbol,tf,0);
               MartiCycleNumBuy+=1;
               DDtrades.PositionModify(ticket,0,0);
              }

           }
        }
     }


   if(MartiActiveSell && (iClose(_Symbol,tf,0)-CurrPriceThreshSell)/_Point>DDcontrolDistance &&
      MartiCycleNumSell<DDcontrolMaxSeriesLen)
     {
      martiLots=MartiInitLotsSell*MathPow(DDcontrolMultiplier,MartiCycleNumSell);

      martiLots=NormalizeVolume(martiLots,_Symbol);
      if(TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) && MQLInfoInteger(MQL_TRADE_ALLOWED)&& (State == "Trade" || State == "Off"))
        {
         if(CheckMoneyForTrade(_Symbol,martiLots,ORDER_TYPE_SELL))
           {
            SymbolInfoTick(Symbol(), mqltick);
            slPrice=mqltick.ask+MartiInitSL*_Point;
            tpPrice=mqltick.ask-MartiInitTP*_Point;
            ticket = SendOrderFunction(_Symbol, ORDER_TYPE_SELL, martiLots, mqltick.bid, magic_number,
                                       Slippage, slPrice, tpPrice, DDcontrolPosComment);
            if(ticket>0)
              {
               ArrayResize(MartingaleSellTickets,ArraySize(MartingaleSellTickets)+1);
               MartingaleSellTickets[ArraySize(MartingaleSellTickets)-1]=ticket;
               CurrPriceThreshSell=iClose(_Symbol,tf,0);
               MartiCycleNumSell+=1;
               DDtrades.PositionModify(ticket,0,0);
              }

           }
        }
     }

// Check for opportunities to close the Martingale series.
   double breakEvenLine, targetProfitline;
   bool success;

// Check the buy group.
   success=ProfitLine_DD(_Symbol, magic_number, mqltick.ask, mqltick.bid, POSITION_TYPE_BUY, MartingaleBuyTickets,
                         MartingaleSellTickets, breakEvenLine, DDcontrolProfit*_Point, targetProfitline);
   if(success && mqltick.bid>=targetProfitline)
     {
      success=CloseOrderList(MartingaleBuyTickets);
      MartiCycleNumBuy=0;
      CurrPriceThreshBuy=EMPTY_VALUE;
      MartiInitLotsBuy=0.0;
      MartiActiveBuy=false;
     }

// Check the buy group.
   success=ProfitLine_DD(_Symbol, magic_number, mqltick.ask, mqltick.bid, POSITION_TYPE_SELL, MartingaleBuyTickets,
                         MartingaleSellTickets, breakEvenLine, DDcontrolProfit*_Point, targetProfitline);
   if(success && mqltick.ask<=targetProfitline)
     {
      success=CloseOrderList(MartingaleSellTickets);
      MartiCycleNumSell=0;
      CurrPriceThreshSell=EMPTY_VALUE;
      MartiInitLotsSell=0.0;
      MartiActiveSell=false;
     }

   return;
}

void HandleBasketClose(long MagicNumber)
  {
   if(!inputUseBasketClose)
      return;
   if(!inputBasketCloseLossAmount)
      return;

   double maxLoss=0;

   if(inputBasketCloseLossAmount > 0)
      maxLoss = 0-inputBasketCloseLossAmount;
   else
      maxLoss = inputBasketCloseLossAmount;

   double totalProfitByMagic = TotalProfitByMagicNumber(MagicNumber);
   if(maxLoss && totalProfitByMagic <= maxLoss)
     {
      CloseAllTradesByMagicNumber(MagicNumber);
      if(inputResetMartingaleAfterBasketClose)
        {
         MartiCycleNumBuy=1;
         MartiCycleNumSell=1;
        }
     }
}

double TotalProfitByMagicNumber(long magic)
  {
   double totalProfit=0;

   for(int i=PositionsTotal()-1; i >= 0; i--)
     {
      ulong position_ticket=PositionGetTicket(i);
      string position_symbol=PositionGetString(POSITION_SYMBOL);
      long  position_magic=PositionGetInteger(POSITION_MAGIC);
      double profit = PositionGetDouble(POSITION_PROFIT);

      if(position_symbol==_Symbol && position_magic==magic)
         totalProfit+=profit;
     }

   return totalProfit;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseAllTradesByMagicNumber(long magic)
  {
   for(int i=PositionsTotal()-1; i >= 0; i--)
     {
      ulong position_ticket=PositionGetTicket(i);
      string position_symbol=PositionGetString(POSITION_SYMBOL);
      long  position_magic=PositionGetInteger(POSITION_MAGIC);

      if(position_symbol==_Symbol && position_magic==magic)
        {
         bool res = trade.PositionClose(position_ticket);
         if(!res)
            Print("Error Closing Position. Ticket: "+(string)position_ticket+" Error: "+(string)GetLastError());
        }
     }
  }

////Swing3 indicator trade filter functions
bool CheckSwing3Filter()
  {
   if(!inputAllowSwing3IndicatorFilter)
      return true;

   double bullishUpper = GetSwing3IndicatorValue(SWING_THREE_BULLISH_UPPER_LINE,1);

   double bullishLower = GetSwing3IndicatorValue(SWING_THREE_BULLISH_LOWER_LINE,1);

   int difference = (int)((MathMax(bullishUpper,bullishLower) - MathMin(bullishUpper,bullishLower)) / _Point);

   string arr[];
   seperateStringToArray(inputListOfPointsDiffrenceForFilter,",",arr);
   for(int i=0; i<ArraySize(arr); i++)
     {
      if(difference==(int)arr[i])
         return true;
     }

   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetSwing3IndicatorValue(int bufferNumber,int shift)
  {
   double array[];
   ArraySetAsSeries(array,true);
   CopyBuffer(swing3IndicatorHandle,bufferNumber,0,shift+1,array);

   return array[shift];
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void seperateStringToArray(string str, string sep, string &arr[])
  {
   ushort u_sep;
   u_sep=StringGetCharacter(sep,0);
   StringSplit(str,u_sep,arr);
  }

///////////////////////////////////////
bool CheckNewCandleForTwoLinesCrossover()
  {
   static datetime currentCandle;
   if(!currentCandle)
     {
      currentCandle = iTime(NULL,inputCloseOrBkevenAtSwing3CrossoverOutSideColoredAreaTimeFrame, 0);
      return false;
     }

   datetime lastestCandle = iTime(NULL,inputCloseOrBkevenAtSwing3CrossoverOutSideColoredAreaTimeFrame, 0);
   if(lastestCandle > currentCandle)
     {
      currentCandle = lastestCandle;
      return true;
     }

   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void HandleSwing3TwoLineCrossoverOutSideColoredArea(long MagicNumber)
  {
   if(!inputCloseOrBkevenAtSwing3CrossoverOutSideColoredArea)
      return;

   if(CheckNewCandleForTwoLinesCrossover())
     {
      if(Swing3LineCrossoverOutSideColoredArea())
        {
         if(inputSwing3TwoLinesCrossoverCloseType==CLOSE_IMMEDIATELY)
           {
            CloseAllPositions(MagicNumber);
            ResetMartingale();
           }
         if(inputSwing3TwoLinesCrossoverCloseType==CLOSE_AT_BREAKEVEN)
           {
            closeTradeAtBreakEven=true;
           }
        }
     }
  }


void CloseAllPositions(long MagicNumber)
  {
   for(int i=PositionsTotal()-1; i >= 0; i--)
     {
      ulong position_ticket=PositionGetTicket(i);
      string position_symbol=PositionGetString(POSITION_SYMBOL);
      long  position_magic=PositionGetInteger(POSITION_MAGIC);

      if(position_symbol==_Symbol && position_magic==MagicNumber)
        {
         bool res = trade.PositionClose(position_ticket);
         if(!res)
            Print("Error Closing Position. Ticket: "+(string)position_ticket+" Error: "+(string)GetLastError());
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ResetMartingale()
  {
   MartiCycleNumBuy=0;
   CurrPriceThreshBuy=EMPTY_VALUE;
   MartiInitLotsBuy=0.0;
   MartiActiveBuy=false;

   MartiCycleNumSell=0;
   CurrPriceThreshSell=EMPTY_VALUE;
   MartiInitLotsSell=0.0;
   MartiActiveSell=false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void HandleCloseTradeAtBreakEven(long MagicNumber)
  {
   if(!closeTradeAtBreakEven)
      return;

   double totalProfit=0;

   for(int i=PositionsTotal()-1; i >= 0; i--)
     {
      ulong position_ticket=PositionGetTicket(i);
      ENUM_POSITION_TYPE type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE);
      string position_symbol=PositionGetString(POSITION_SYMBOL);
      long  position_magic=PositionGetInteger(POSITION_MAGIC);
      double positionProfits = PositionGetDouble(POSITION_PROFIT);

      if(position_symbol==_Symbol && position_magic==MagicNumber)
         totalProfit += positionProfits;
     }

   if(totalProfit>=0)
     {
      CloseAllPositions(MagicNumber);
      closeTradeAtBreakEven = false;
      ResetMartingale();
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool Swing3LineCrossoverOutSideColoredArea()
  {
   if(!CheckSwing3TwoLinesOutSideColoredArea())
      return false;

   double bullUpperLine1 = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BUFFER_ONE,1);
   double bullLowerLine1 = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BUFFER_TWO,1);

   double bullUpperLine2 = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BUFFER_ONE,2);
   double bullLowerLine2 = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BUFFER_TWO,2);

   if(bullUpperLine1 > bullLowerLine1 && bullUpperLine2 < bullLowerLine2)
      return true;
   if(bullLowerLine1 > bullUpperLine1 && bullLowerLine2 < bullUpperLine2)
      return true;

   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool CheckSwing3TwoLinesOutSideColoredArea()
  {
   double bullishUpper = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BULLISH_UPPER_LINE,1);
   double bullishLower = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BULLISH_LOWER_LINE,1);

   double colUpper = MathMax(bullishUpper, bullishLower);
   double colLower = MathMin(bullishUpper, bullishLower);

   double bullUpperLine1 = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BUFFER_ONE,1);
   double bullLowerLine1 = GetSwing3IndicatorValueForTwoLines(SWING_THREE_BUFFER_TWO,1);

   if((bullUpperLine1 > colUpper || bullUpperLine1 < colLower) && (bullLowerLine1 > colUpper || bullLowerLine1 < colLower))
      return true;

   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetSwing3IndicatorValueForTwoLines(int bufferNumber,int shift)
  {
   double array[];
   ArraySetAsSeries(array,true);
   CopyBuffer(swing3IndicatorHandleForTwoLines,bufferNumber,0,shift+1,array);

   return array[shift];
  }


///////////////////////////
bool CheckSwing3PoiintRangeFilter()
  {
   if(!inputAllowSwing3IndicatorPointRangeFilter)
      return true;

   double bullishUpper = GetSwing3IndicatorValueForPointRange(SWING_THREE_BULLISH_UPPER_LINE,1);
   double bullishLower = GetSwing3IndicatorValueForPointRange(SWING_THREE_BULLISH_LOWER_LINE,1);

   int difference = (int)((MathMax(bullishUpper,bullishLower) - MathMin(bullishUpper,bullishLower)) / _Point);

   if(difference >= inputAllowSwing3IndicatorPointRangeFilterLower && difference <= inputAllowSwing3IndicatorPointRangeFilterHigher)
      return true;
   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetSwing3IndicatorValueForPointRange(int bufferNumber,int shift)
  {
   double array[];
   ArraySetAsSeries(array,true);
   CopyBuffer(swing3IndicatorPointRangeFilterHandle,bufferNumber,0,shift+1,array);

   return array[shift];
  }

//+------------------------------------------------------------------+
//----------------------------------------- Trade Close function ---------------------------------------
void CloseTrades(string pSymbol, ulong magicNumber, string pComment)
  {

   for(int i= PositionsTotal() - 1 ; i>=0 ; i--)
     {
      ResetLastError();
      ulong positionTicket = PositionGetTicket(i);
      PositionSelectByTicket(positionTicket);
      string posSymbol     = PositionGetString(POSITION_SYMBOL);
      ulong  posType       = PositionGetInteger(POSITION_TYPE);
      ulong  posMagic      = PositionGetInteger(POSITION_MAGIC);

      if(posMagic == magicNumber && posType == ORDER_TYPE_BUY && posSymbol == pSymbol)
        {
         trade.PositionClose(positionTicket);
         Print(pComment);
        }
      else
         if(posMagic == magicNumber && posType == ORDER_TYPE_SELL && posSymbol == pSymbol)
           {
            trade.PositionClose(positionTicket);
            Print(pComment);
           }
     }
  }
//+------------------------------------------------------------------+
double LivePNL(string pSymbol, ulong pMagic)
  {
   double pnl = 0;
   for(int i = PositionsTotal() - 1 ; i >= 0; i--)
     {
      ResetLastError();
      ulong positionTicket = PositionGetTicket(i);
      PositionSelectByTicket(positionTicket);
      string posSymbol     = PositionGetString(POSITION_SYMBOL);
      ulong  posMagic      = PositionGetInteger(POSITION_MAGIC);
      double posProfit     = PositionGetDouble(POSITION_PROFIT);
      double posSwap       = PositionGetDouble(POSITION_SWAP);
      if(posSymbol == pSymbol && posMagic == pMagic)
        {
         pnl = pnl + posProfit + posSwap;
        }
     }
   return pnl;
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
double ValueBuffers(int pHandle,int pLineBuffer,int pShift)
  {
   ResetLastError();
   double arr[];
   ArraySetAsSeries(arr,true);
   bool fillResult = CopyBuffer(pHandle,pLineBuffer,0,4,arr);
   if(fillResult == false)
     {
      Print("FILL_ERROR: ", GetLastError());
     }
   double Value = arr[pShift];
   return Value;
  }
//+------------------------------------------------------------------+

bool CheckSwingIndicatorHandle(int handle, ENUM_TIMEFRAMES period)
{
  if(handle==INVALID_HANDLE)
  {
  //--- tell about the failure and output the error code
    PrintFormat("Failed to create handle of the swing indicator for the symbol %s/%s, error code %d",
                EnumToString(period),
                GetLastError());

    return false;
  }

  return true;
}

bool CheckIBandIndicatorHandle(int handle, ENUM_TIMEFRAMES period)
{
  if(handle==INVALID_HANDLE)
  {
    PrintFormat("Failed to create handle of the Support and Resistance indicator for the symbol %s/%s, error code %d",
                  EnumToString(period),
                  GetLastError());

    return false;
  }

  return true;
}

bool FillSwingTfHandleAndMagicArr(ENUM_TIMEFRAMES timeframe,long magic)
{
  int swingHandle = iCustom(_Symbol, timeframe,indName,ma_1,ma_2,method,AppPrice,signal,signal2,s_method2,s_method,color1,color2,color3,color4);
  if(!CheckSwingIndicatorHandle(swingHandle, timeframe)) return false;

  TF_INDICATOR_HANDLE_MAGIC newObj;
  newObj.timeframe = timeframe;
  newObj.swingHandle = swingHandle;
  newObj.magic = magic;

  int size = ArraySize(swingTfHandleAndMagicArr);
  ArrayResize(swingTfHandleAndMagicArr, size + 1);
  swingTfHandleAndMagicArr[size] = newObj;

  return true;
}